<?php 
/* 
Script writtten by Gavin @ MixStream.net (c) 2007

This script is free to use and edit as you wish.

You may share this script, but please keep these credits in place.
*/

// CONFIGURATION //

// Server options //

$ip[1] = "87.117.228.59"; // IP or host name of your server
$port[1] = "8288"; // Server Port

$ip[2] = "91.186.4.51";
$port[2] = "8000";

$ip[3] = "66.45.246.178";
$port[3] = "8080";

$ip[4] = "66.45.246.202";
$port[4] = "8434";

/*
You can add as many servers as you need, 
but note that the more servers you add, 
the longer it will take for the image to load.
*/

// Image options // 
$image_format = "jpeg"; // Image format can be gif, jpeg or png (ensure that you put jpeg and not jpg!)
$backgound_image_url = "http://mixstream.net/blank_468x60.jpg"; // Full URL of background image - format MUST match $image_format
$text_colour = "255,0,0"; // The colour of the text in the format R,G,B (e.g, Red: 255,0,0 / Green: 0,255,0 / Blue: 0,0,255). These parameters are integers between 0 and 255 and may not work well if your image is a GIF
$text_size = "4"; // Size of text, the bigger the number, the bigger the text 
$song_text_x = "10"; // X position of song title
$song_text_y = "10"; // Y position of song title
$listeners_text_x = "10"; // X position of listener count
$listeners_text_y = "40"; // Y position of listener count

// Text options //
$song_text_format = "Currently playing: {song}"; // {song} will be replaced by the song title
$listeners_text_format = "{listeners} people listening now!"; // {listeners} will be replaced by the listener number

////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////
// NO NEED TO EDIT BELOW UNLESS YOU KNOW WHAT YOU ARE DOING ////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////
if ($image_format == "gif")
	{
	$im = @imagecreatefromgif ($backgound_image_url);
	}
if ($image_format == "jpeg")
	{
	$im = @imagecreatefromjpeg ($backgound_image_url);
	}
if ($image_format == "png")
	{
	$im = @imagecreatefrompng ($backgound_image_url);
	}
if (!$im) 
	{ 
	print "<h1>There has been an error</h1>One of the following has happened:<br />1) You didn't enter a URL for $" . "backgound_image_url <br />2) The format of $" . "backgound_image_url does not match $" . "image_format <br />3) The image does not exist or could not be retreived.";
	exit; 
	} 
Header("Content-type: image/$image_format"); 
$servers = count($ip);
$i = "1";
while($i<=$servers)
	{
	$fp = @fsockopen($ip[$i],$port[$i],$errno,$errstr,4);
	if (!$fp) 
		{ 
		$listeners[$i] = "0";
		} 
	else
		{ 
		fputs($fp, "GET /7.html HTTP/1.0\r\nUser-Agent: Mozilla\r\n\r\n");
		while (!feof($fp)) 
			{
			$info = fgets($fp);
			}
		$info = str_replace('<HTML><meta http-equiv="Pragma" content="no-cache"></head><body>', "", $info);
		$info = str_replace('</body></html>', "", $info);
		$stats = explode(',', $info);
		if (empty($stats[1]) )
			{
			$listeners[$i] = "0";
			}
		else
			{
			if ($stats[1] == "1")
				{
				$song[$i] = $stats[6];
				$listeners[$i] = $stats[0];
				}
			else
				{
				$listeners[$i] = "0";
				}
			}
		}
	$i++;
	} 
$total_listeners = array_sum($listeners);
$song_title = $song[1];
$split_colour = split (",", $text_colour); 
$text_colour = imagecolorallocate($im, $split_colour[0], $split_colour[1], $split_colour[2]); 
$song_text = str_replace("{song}", $song_title, $song_text_format); 
$listeners_text = str_replace("{listeners}", $total_listeners, $listeners_text_format);
imagestring($im, $text_size, $song_text_x, $song_text_y, $song_text, $text_colour); 
imagestring($im, $text_size, $listeners_text_x, $listeners_text_y, $listeners_text, $text_colour); 
if ($image_format == "gif")
	{
	imagegif($im); 
	}
if ($image_format == "jpeg")
	{
	imagejpeg($im); 
	}
if ($image_format == "png")
	{
	imagepng($im); 
	}
imagedestroy($im);
?>